"use strict";

var _react = _interopRequireDefault(require("react"));

var _immutable = require("immutable");

var _reactTestingLibrary = require("react-testing-library");

require("react-testing-library/cleanup-after-each");

require("jest-dom/extend-expect");

var _InlineSelectPreview = _interopRequireDefault(require("./InlineSelectPreview"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = [{
  value: 'foo',
  label: 'Foo'
}, {
  value: 'bar',
  label: 'Bar'
}, {
  value: 'baz',
  label: 'Baz'
}];
describe('InlineSelectPreview', function () {
  it('should render 1 value', function () {
    var _render = (0, _reactTestingLibrary.render)(_react.default.createElement(_InlineSelectPreview.default, {
      value: "foo",
      field: (0, _immutable.fromJS)({
        options: options,
        name: 'radio_1'
      })
    })),
        getByText = _render.getByText,
        queryByText = _render.queryByText;

    expect(getByText('Foo')).toBeInTheDocument();
    expect(queryByText('Bar')).not.toBeInTheDocument();
    expect(queryByText('Baz')).not.toBeInTheDocument();
  });
  it('should render list of values', function () {
    var _render2 = (0, _reactTestingLibrary.render)(_react.default.createElement(_InlineSelectPreview.default, {
      value: ['foo', 'baz'],
      field: (0, _immutable.fromJS)({
        options: options,
        name: 'radio_1'
      })
    })),
        getByText = _render2.getByText,
        queryByText = _render2.queryByText;

    expect(getByText('Foo')).toBeInTheDocument();
    expect(queryByText('Bar')).not.toBeInTheDocument();
    expect(getByText('Baz')).toBeInTheDocument();
  });
});
//# sourceMappingURL=InlineSelectPreview.test.js.map